#!/usr/bin/perl
# tpChat IRC proxy CGI by T.Yokoyama 04/12/2001

# use socket lib for perl5
use Socket;

# password for tpChat.cgi
$pass = '';

# password for IRC Server
$ircpass = '';

&get_cookie;
if($pass && ($val{'pass'} ne $pass)) {
  print "Content-type: text/plain\n\n";
  print "deny";
  exit;
}

# get parameters
$tmp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$tmp);
foreach $pair (@pairs) {
 ($name,$value) = split(/=/,$pair);
 $buf{$name} = $value;
}
($sv,$port) = split(/:/,$buf{'server'});
$channel = $buf{'channel'};
$nick = $buf{'nick'};
$loginname = $buf{'loginname'};
$realname = $buf{'realname'};

# only IRC port for security
if($port < 6660 || $port > 6669) { err('!bad port number.'); }

# connect to server
$iaddr = inet_aton($sv);
$paddr = sockaddr_in($port,$iaddr);
$proto = getprotobyname('tcp');
socket(SV,PF_INET,SOCK_STREAM,$proto) || err('!cannot create server socket.');
connect(SV,$paddr) || err('!cannot connect server.');
select((select(SV), $| = 1)[0]);

# listen for client
socket(LS,PF_INET,SOCK_STREAM,$proto) || err('!cannot create client socket.');
setsockopt(LS,SOL_SOCKET,SO_REUSEADDR,1) || err("!setsockopt: $!");
bind(LS,sockaddr_in(0,INADDR_ANY)) || err('!cannot bind.');
listen(LS,SOMAXCONN) || err('!cannot listen.');
($cport,$tmp) = unpack_sockaddr_in(getsockname(LS));

# show listen port and exit cgi
$| = 1;
if(fork) {
  if($channel) { &cookie(); }
  print "Content-type: text/plain\n\n";
  print $cport;
  exit;
}
close(STDOUT);

# accept client
alarm 30;
accept(CL,LS) || die '!cannot accept.';
select((select(CL), $| = 1)[0]);
alarm 0;

# client name
($tmp,$addr) = unpack_sockaddr_in(getpeername CL);
$hostname = gethostbyaddr($addr,AF_INET);
$hostaddr = inet_ntoa($addr);
$0 = "ircproxy($hostname -> $sv)";

# init proxy
$rin = $win = $ein = '';
$sv_no = fileno(SV);
$cl_no = fileno(CL);
vec($rin,$sv_no,1) = 1;
vec($rin,$cl_no,1) = 1;

# send server password
if($ircpass) {
  print SV "PASS $ircpass\n";
}

# proxy
while(1) {
 $nfound = select($rout = $rin,$wout = $win,$eout = $ein,undef);
 if(vec($rout,$sv_no,1)) {
   if(sysread(SV,$mes,4096)) {
     print CL $mes;
   } else { exit; }
 }
 if(vec($rout,$cl_no,1)) {
   if(sysread(CL,$mes,4096)) {
     print SV $mes;
   } else { exit; }
 }
}

# error message
sub err {
 print "Content-Type: text/plain\n\n";
 print @_[0] . "\n";
 exit;
}

# set cookie
sub cookie {
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time + 30*24*60*60);
 @week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
 @month = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
 $date = sprintf("%s\, %02d\-%s\-%04d %02d:%02d:%02d GMT",$week[$wday],$mday,$month[$mon],$year+1900,$hour,$min,$sec);
    print "Set-Cookie: channel=$channel,nick=$nick,loginname=$loginname,realname=$realname,server=$sv,port=$port,pass=$pass; expires=$date\n";
}

# get cookie
sub get_cookie {
  $cookie = $ENV{'HTTP_COOKIE'};
  $cookie =~ s/;/,/g;
  $cookie =~ s/ //g;
  @pairs = split(/,/,$cookie);
  foreach $pair (@pairs) {
   ($name,$value) = split(/=/,$pair);
   $value =~ s/\+/ /g;
   $value =~ s/%(..)/pack("c",hex($1))/ge;
   $val{$name} = $value;
  }
}
